<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

/**
 * Ce contrôleur a pour but la gestion des images.
 * @author jub
 *
 */
class Image extends MY_Controller {

	function __construct() {
		parent::__construct();
		$this->load->library('doctrine');
		$this->load->helper('html');
		$this->load->helper('url');
			
	}

	/**
	 * Affiche le formulaire d'upload
	 */
	function create(){
		$this->load->view('backoffice/templates/header');
		$this->load->view('backoffice/upload_view');
		$this->load->view('backoffice/templates/footer');

	}

	/**
	 * Utilisé après validation du formulaire d'upload;
	 */
	function createOk(){
		//L'identifiant de l'utilisateur en cours est recupéré, il sera utilisé pour associer l'image à un utilisateur.
		$varsession = $this->session->userdata('loggedin');
		$id = $varsession['id'];
		
		$em = $this->doctrine->em;
		$repository = $em->getRepository('models\Image');

		//Le fichier uploadé devra avoir le même nom que l'url
		//Ce champ etant génére automatiquement par le sgbd, 
		//nous allons pour le moment le nommer temp
		
		$url='temp';
		//le repertoire contenant notre galerie
		$gallery_path = realpath(APPPATH . '..'.DIRECTORY_SEPARATOR.'ressources'.DIRECTORY_SEPARATOR.'medias'.DIRECTORY_SEPARATOR.'images').DIRECTORY_SEPARATOR;
		//le repertoire contenant les miniatures
		$miniature_path = $gallery_path.DIRECTORY_SEPARATOR.'miniatures'.DIRECTORY_SEPARATOR;
		
		//la configuaryion utilisée pour l'upload
		$config['upload_path'] = $gallery_path; //ou le fichier sera déposé
		$config['allowed_types'] = 'gif|jpg|png|jpeg'; //les types de fichiers autorisés
		$config['max_size']	= '100'; //La taille maximum de l'image en Ko
		$config['max_width']  = '1024'; //La largueur maximum en pixels
		$config['max_height']  = '768'; //la haiteur maximum en pixels
		$config['file_name']= $url; //le nom du fichier qui sera créé
		$config['overwrite']=true; //supprime le fichier si il existe déjà

		//charge la librairie d'upload avec la configuration choisie
		$this->load->library('upload', $config);
		//tente l'upload
		$uploadOk = $this->upload->do_upload();
		//apres l'upload le fichier se nome temp.ext ou ext est le fichier uploade
		
		if ($uploadOk){
			//Si l'upload a réussi on tent la fabrication de la miniature
			
			//on récupere l'image uploadée
			$image_data = $this->upload->data();

			//la configuration pour la gestion de la miniature
			$config = array(
      		'source_image' => $image_data['full_path'], //get original image
      		'new_image' => $gallery_path.'/miniatures', //save as new image //need to create thumbs first
      		'maintain_ratio' => true, //mainitien le ratio
      		'width' => 150, //la largueur de la miniature sera de 250px 
    		'height' => 100 //la hauteur de la miniature sera de 100px

			);

			$this->load->library('image_lib', $config); //load library
			$resizeOk =$this->image_lib->resize(); //redimensione et créer la miniature
			if ($resizeOk)
			{
				//la génération de la miniature a réussie
				//on inscrit l'image dans la base en utilisant sa description et l'identifiant de l'utilisateur
				$description = $this->input->post('description');
				$image=$repository->create($description, $id);
				//on récupere l'url de l'image crée
				$newUrl=$image->getURL();
				//Le fichier temp est renomé avec l'url et la bonne extension
				try {
				rename($gallery_path.$url.$image_data['file_ext'],$gallery_path.$newUrl.$image_data['file_ext']);
				rename($miniature_path.$url.$image_data['file_ext'], $miniature_path.$newUrl.$image_data['file_ext']);
				}
				catch (Exception $e){
					//en cas d'erreur on supprime l'image de la base de donnee.
					$repository->delete($url);
					
				}
				//redirection vers la page d'accueil du backoffice
				redirect('backoffice/accueil');
			}
		}
		//en cas de problème d'upload un message est affiché
		$data['error']= $this->upload->display_errors();
		$this->load->view('backoffice/templates/header');
		$this->load->view('backoffice/upload_error_view', $data);
		$this->load->view('backoffice/templates/footer');
		
	}

	public function display($url)
	{
		$em = $this->doctrine->em;
		$repository = $em->getRepository('models\Image');
		$data['image']= $repository->getImageByURL($url);
		$this->load->view('backoffice/templates/header');
		$this->load->view('backoffice/gestion_image_view', $data);
		$this->load->view('backoffice/templates/footer');
	}
	
	public function delete($url)
	{
		$em = $this->doctrine->em;
		$repository = $em->getRepository('models\Image');
		$repository->delete($url);
		redirect('backoffice/accueil');	
	}
	
	public function updateDescription()
	{
		$url = $this->input->post('url');
		$description = $this->input->post('description');
		$em = $this->doctrine->em;
		$repository = $em->getRepository('models\Image');
		$repository->updateDescription($url, $description);
		redirect('backoffice/accueil');	
	}
}

?>
