<?php



/**
 * Description of UtilisateurDepot
 *
 * @author jub
 */

namespace models\repositories;

/**
 * Le dépôt utilisateur
 * @author jub
 *
 */
class UtilisateurRepository extends \Doctrine\ORM\EntityRepository {

	/**
	 * Crée un utilisateur avec un login, un mot de passe, un niveau et une description choisie
	 * @param unknown_type $login le login
	 * @param unknown_type $password le mot de passe
	 * @param unknown_type $level le niveau (0 pour les administrateurs)
	 * @param unknown_type $description la description
	 */
	public function create($login,$password, $level, $description) {
		$em = $this->getEntityManager();
		//creation d'un utilisateur
		//TODO
		//--------------------------------------------------------------------------------------------------------------
		
		//--------------------------------------------------------------------------------------------------------------
		try {
			$em->flush();
		} catch (\Exception $e) {
			//echo $e->getMessage();
		}
			
	}

	/**
	 * Permet de supprimer un utilisateur en connaîssant son identifiant
	 * @param unknown_type $id l'identifiant
	 */
	public function delete($id) {
		$em = $this->getEntityManager();

		try {
			//suppression d'un utilisateur
			//--------------------------------------------------------------------------------------------------------------
			//TODO
			
			//--------------------------------------------------------------------------------------------------------------
			$em->flush();
		} catch (\Exception $e) {

		};
	}

	/**
	 * Permet de vérifier la correspondance login, mot de passe
	 * @param unknown_type $login le login
	 * @param unknown_type $password le mot de passe
	 * @return boolean true si le login et le mot de passe correspondent false sinon
	 */
	public function authenticate($login, $password)
	{
		$CI = & get_instance();
		$CI->load->library('encrypt');
		$utilisateur = $this->findOneByLogin($login);
			
		$res = FALSE;
		if ($utilisateur != NULL)
		{
			
			$res = $utilisateur->authenticate($password);
			
		}
		return $res;
	}

	/**
	 * Permet à partir du login de récuperer un utilisateur.
	 * L'opération est posible car le login est unique
	 * @param unknown_type $login le login de l'utilisateur recherché
	 * @return l'utilisateur correspondant au login
	 */
	public function getUtilisateurByLogin($login)
	{
		$em = $this->getEntityManager();
		$utilisateur = $this->findOneByLogin($login);
		return $utilisateur;
	}

	/**
	 * Permet à partir du 'lidentifiant de récuperer un utilisateur.
	 * L'opération est posible car le l'identifiant est unique
	 * @param unknown_type $id l'identifiant de l'utilisateur recherché
	 * @return l'utilisateur correspondant à l'identifiant
	 */
	public function getUtilisateurById($id)
	{
		$em = $this->getEntityManager();
		$utilisateur = $this->findOneById($id);
		return $utilisateur;
	}

	/**
	 * Permet de modifier un utilisateur
	 * @param unknown_type $id l'identifiant de l'utilisateur ne peut-être modifié
	 * @param unknown_type $login le nouveau login
	 * @param unknown_type $password le nouveau mot de passe
	 * @param unknown_type $level le nouveau niveau
	 * @param unknown_type $description la nouvelle description
	 */
	public function updateUtilisateur($id, $login, $password, $level, $description){
		//l'identifiant ne peut-être modifié
		$em = $this->getEntityManager();
		//modification de l'utilisateur
		//--------------------------------------------------------------------------------------------------------------
		//TODO
		
		//--------------------------------------------------------------------------------------------------------------
		$em->flush();
	}

}

?>
